/*
	========================================================
						Dalek v0.9
	========================================================
	(c) 2005 by Lutz Schubert
	
	"Doctor Who" and the "Dalek" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Dalek.kon for version history
*/
// TODO: border: turn around
// TODO: stop with mouse, look at it
// TODO: eye & arms
// TODO: make theaddir function



// move the Dalek
function moveDalek()
{
//	print("mouse:" + system.event.screenX + ", " + system.event.screenY);

	//print(wndDalek.hOffset);
	if ( ((wndDalek.hOffset+dirx) > screen.availLeft) && ((wndDalek.hOffset+dirx) < (screen.availLeft + screen.availWidth - wndDalek.width)) )
	{
		realx += dirx;
		wndDalek.hOffset += realx;
		
		realx = realx - Math.round(realx);
	} else { rotdir = 4; }

	if ( ((wndDalek.vOffset+diry) > screen.availTop) && ((wndDalek.vOffset+diry) < (screen.availTop + screen.availHeight - wndDalek.height)) )
	{
		realy += diry;
		wndDalek.vOffset += realy;

		realy = realy - Math.round(realy);
	} else { rotdir = 4; }
	
	// rotate dalek
	if (random(100)>98) 
	{ 
		rotdir = random( -7,8 );
	}

	// rotate head
	if (random(100)>95) 
	{ 
		newheaddir = direction + random( -4, 5 );	// turn only max 180 (clockwise or ccw) - relative to base
	}

	// rotate eye
	if (random(100)>96) 
	{ 
		// SET NEW ROTATION
		neweyedir = random( -2, 3 );
	}
	return true;	//continue
}

// rotate the Dalek
function rotateDalek()
{
	if (rotdir==0) {return true;}	// stop

	var ct = 1;
	if (rotdir<0) { ct=-1; }
	
	direction += ct;
	if (direction == -1) { direction = 15; }
	if (direction == 16) { direction =  0; }
	rotdir -= ct;
	//print("new direction: " + direction);
	
	imgBase.src = "Base/Base_" + direction + ".png";
	imgRArm.src = "Base/RightArm/RArm_0_1_" + direction + ".png";
	imgLArm.src = "Base/LeftArm/LArm_0_0_" + direction + ".png";
	if (direction<8)
	{
		imgRArm.zOrder = 5;
		imgLArm.zOrder = 6;
	}
	else
	{
		imgRArm.zOrder = 6;
		imgLArm.zOrder = 5;
	}
	if (!exterminate) { newheaddir += ct; }
	
	dirx = calcdirx( direction );
	diry = calcdiry( direction );
	
	return true;	//continue until done(!)
}

// rotate the Dalek's head
function rotateHead()
{
	if (newheaddir< 0) { newheaddir += 16; }
	if (newheaddir>15) { newheaddir -= 16; }
	if (curheaddir==newheaddir) {return true;}	// do not rotate

	var ct = 1;
	if (curheaddir>=8)
	{	
		if ( (newheaddir>(curheaddir-8)) && (newheaddir<curheaddir) ) { ct = -1; }
	} else 
	{
		if ( (newheaddir<curheaddir) || (newheaddir>(curheaddir+8)) ) { ct = -1; }
	}
	
	curheaddir += ct;
	if (curheaddir > 15) { curheaddir-=16; }
	if (curheaddir < 0 ) { curheaddir+=16; }
	
	imgHead.src = "Head/Head_" + curheaddir + ".png";
	imgEye.src = "Head/Eye_"+cureyedir+"_" + curheaddir + ".png";

	return true;	//continue until done(!)
}

// follow the cursor
function followMouse()
{
	var relX = system.event.screenX - wndDalek.hOffset - 0.5*wndDalek.width;
	var relY = system.event.screenY - wndDalek.vOffset - 75;		// eye height
	
	absheaddir = -Math.round( 6*Math.tan( relX/imgVisArea.width ) );
	var teyedir = -Math.round( 6*Math.tan( relY/150 ) );
	//print("mousey: "+relY + " => " + teyedir )
	
	if (!exterminate) 
	{ 
		newheaddir = absheaddir; 
		if (newheaddir< 0) { newheaddir+=16; }
		if (newheaddir>15) { newheaddir-=16; }
		
		if ((teyedir>=-1) && (teyedir<=2)) { neweyedir=teyedir; }
	}
//TODO:EYE	
	return true;
}

// rotate the Dalek's eye
function rotateEye()
{
	if (cureyedir==neweyedir) {return true;}	// do not rotate

	var ct = 1;
	if (cureyedir>neweyedir) { ct=-1; }
	
	cureyedir += ct;

	imgEye.src = "Head/Eye_"+cureyedir+"_" + curheaddir + ".png";

	return true;	//continue until done(!)
}

function calcdirx( direction )
{
	var angle = direction * (360/16);
//	print( "direction " + direction + "( x:" + speed*Math.sin( angle*(2*3.14159/360) ) + ", y:" + 0.5*speed*Math.cos( angle*(2*3.14159/360) )  );
	return -speed*Math.sin( angle*(2*3.14159/360) );
}

function calcdiry( direction )
{
	var angle = direction * (360/16);
	return 0.3*speed*Math.cos( angle*(2*3.14159/360) ) ;
}

// initialise the widget
// covering reactions to preference changes
function init()
{
	fps = preferences.framespeed.value;
	print(fps);

	// start all animations anew
	animDalekMovement.kill();
	animDalekMovement = new CustomAnimation( 1000/fps, moveDalek );
	animator.start( animDalekMovement );	//??? tunnelAnimation.start();  STARTS AUTOMATICALLY WHEN JAVASCRIPT ENDS

	// ANIMATION 2: Rotate Dalek (only with change of direction )
	animDalekRotation.kill();
	animDalekRotation = new CustomAnimation( 2*1000/fps, rotateDalek );
	animator.start( animDalekRotation );

	animHeadRotation.kill();
	animHeadRotation = new CustomAnimation( 2*1000/fps, rotateHead );
	animator.start( animHeadRotation );

	animEyeRotation.kill();
	animEyeRotation = new CustomAnimation( 2*1000/fps, rotateEye );
	animator.start( animEyeRotation );
}

