/*
	========================================================
						Dalek  v0.9
	========================================================
	(c) 2005 by Lutz Schubert
	
	"Doctor Who" and the "Dalek" are trademarks of the BBC
	Please visit http://www.bbc.co.uk/doctorwho
						
							== * ==
	
	This program is free for distribution, any commercial
	use is strcitly prohibited. All images are copyright-
	protected and may not be distributed independently of
	this software without explicit permission by the author.
	
	The author takes no liability for any damages caused
	by usage of this program. No warranty is given.
	
	========================================================
	refer to Dalek.kon for version history
*/

include("Functions.js");

// WINDOW 1
// initialise main values (static)
//------------------------------------
//  06 07 08 09 10
//  05                11
//  04      -+-      12
//  03                13
//  02 01 00 15 14
var direction = 4;		
var rotdir = 0;
var curheaddir = 4;		// current direction of head (absolute)
var newheaddir = 4;		// new direction of head
var cureyedir = 0;		// current direction of eye
var neweyedir = 0;		// new direction...

var speed = 2;
var dirx = -speed;		// initial direction: left
var diry = 0;
var fps = 24;

wndDalek.hOffset = 200;
wndDalek.vOffset = 200;

var realx = 0.0;	// TODO : only after-comma
var realy = 0.0;	// TODO

var exterminate = false;
var dalekrotationactive = false;

// initiate the animations
//----------------------------
// ANIMATION 1: Move Dalek (until clicked)

var animDalekMovement = new CustomAnimation( 1000/fps, moveDalek );
animator.start( animDalekMovement );	//??? tunnelAnimation.start();  STARTS AUTOMATICALLY WHEN JAVASCRIPT ENDS

// ANIMATION 2: Rotate Dalek (only with change of direction )
var animDalekRotation = new CustomAnimation( 2*1000/fps, rotateDalek );
animator.start( animDalekRotation );

var animHeadRotation = new CustomAnimation( 2*1000/fps, rotateHead );
animator.start( animHeadRotation );

var animEyeRotation = new CustomAnimation( 2*1000/fps, rotateEye );
animator.start( animEyeRotation );

// ANIMATION 3: Follow the Mouse With the Head
var animMouseFollow;// = new CustomAnimation( 2*1000/fps, followMouse );


init();